package hdm.mi.growbros.service;

import hdm.mi.growbros.models.dto.CustomPageDto;
import hdm.mi.growbros.models.plant.Plant;
import hdm.mi.growbros.repositories.PlantRepository;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.boot.test.mock.mockito.MockBean;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;
import org.springframework.test.context.ActiveProfiles;

import java.util.List;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.mockito.Mockito.verify;
import static org.mockito.Mockito.when;

@SpringBootTest
@ActiveProfiles("test")
class PlantsServiceTest {
    @MockBean
    private PlantRepository plantRepository;

    @Autowired
    private PlantsService plantsService;

    @Test
    void getPlants_withPageEmpty() {
        final PageRequest pageable = PageRequest.of(0, 10);
        PageImpl<Plant> page = new PageImpl<>(List.of());
        final CustomPageDto<Plant> expected = new CustomPageDto<>(0, 0, page.getContent());
        when(plantRepository.findAll(pageable))
                .thenReturn(page);

        CustomPageDto<Plant> actual = plantsService.getPlants(0, 10);

        verify(plantRepository).findAll(pageable);
        assertEquals(actual.currentPage(), expected.currentPage());
        assertEquals(actual.pageSize(), 0);
        assertEquals(actual.content(), expected.content());
    }
}